%% SGfilter01
%% Filtrace namench dat pomoc Savitzky-Golay filtru
clc, close all, clear all
global to qo qs
global L
global i1 i2;

% to ... vektor as men - nezvisl veliina
% po ... vektor namench tlak - zvisl veliina
% qo ... vektor namench poloh - zvisl veliina
% No ... poet namench bod

%% Pehled dat
% to, qo, No ... originln namen data
% t , q , No  ... upraven namen data
% ti, qi, Ni ... ekvidistantn interpolovan data
% ti, qf, Ni ... ekvidistantn filtrovan data
% to, qs, No ... zptn pevzorkovan data
% to, qa, N ... data vypoten z modelu

%% Volba jazyka (1 - etina, 2 - anglitina)
jazyk = menu('Jazyk nabdek a obrzk / Language of menus and figures',...
    'etina / Czech','Anglitina / English');
close(gcf)

%% Naten experimentlnch dat
switch jazyk
    case 1
        vstup = menu('Volba typu datovch soubor',...
            'Textov soubor s hodnotami oddlenmi oddlovaem - *.csv',...
            'Seit aplikace MS Excel - *.xls');
    case 2
        vstup = menu('Selection of the data files type',...
            'Text file with values separated by a separator - *.csv',...
            'MS Excel workbook - *.xls');
end
close(gcf)
if vstup < 1 || vstup > 2
    vstup = 1;
end
switch jazyk
    case 1 
        datsoubor = input(' Zadej jmno datovho souboru: ','s');
    case 2
        datsoubor = input(' Enter the name of the data file: ','s');
end
[pathstr, name, ext] = fileparts(datsoubor);
switch vstup
    case 1
        if strcmp(ext,'')
            datsoubor = [datsoubor,'.csv'];
        else
            if ~strcmp(ext,'.csv')
                datsoubor = strrep(datsoubor,ext,'.csv');
            end
        end
    case 2
        if strcmp(ext,'')
            datsoubor = [datsoubor,'.xls'];
        else
            if ~strcmp(ext,'.xls')
                datsoubor = strrep(datsoubor,ext,'.xls');
            end
        end
end
fid = fopen(datsoubor);
if fid < 0
    disp(' ')
switch jazyk
    case 1
        disp(['Soubor ',datsoubor,' v pracovn sloce neexistuje!!!'])
    case 2
        disp(['The file ',datsoubor,' does not exists in the working folder!!!'])
end
    disp(' ')
    return
end
switch vstup
    case 1
        switch jazyk
            case 1
                oddelovac = menu(...
                    ['Vbr oddlovae hodnot v souboru ',datsoubor],...
                    'Stednk','rka');
            case 2
                oddelovac = menu(...
                    ['Value separator in the file ',datsoubor],...
                    'Semicolon','Comma');
        end
        close(gcf)
        switch oddelovac
            case 1
                delimiter = ';';
            case 2
                delimiter = ',';
        end
        disp(' ')
        switch jazyk
            case 1
                disp(' Probh ten dat ze vstupnho textovho souboru!!!')
            case 2
                disp(' Reading data from the input text file!!!')
        end
        disp(' ')
        data = textscan(fid,'%f %f %f','delimiter',delimiter);
        fclose(fid);
        to = data{1};
        qo = data{2};
        po = data{3};
        No = length(to);
        switch jazyk
            case 1
                disp([' Peteno ', num2str(No), ' dk!'])
            case 2
                disp([' ', num2str(No), ' rows were read!'])
        end
        disp(' ')
        if No == 0
            switch jazyk
                case 1
                    disp([' Datov soubor ', datsoubor, ' je przdn!!!'])
                case 2
                    disp([' The data file ', datsoubor, ' is empty!!!'])
            end
            disp(' ')
            return
        end
        xlsdatsoubor = strrep(datsoubor,'csv','xls');
    case 2
        fclose(fid);
        data = xlsread(datsoubor)
        if isempty(data)
            switch jazyk
                case 1
                    disp([' Datov soubor ', datsoubor, ' je przdn ', ...
                        'nebo neobsahuje seln hodnoty!!!'])
                case 2
                    disp([' The date file ', datsoubor, ' is empty ', ...
                        'or does not contain numerical values!!!'])
            end
            disp(' ')
            return
        end
        to = data(:,1);
        qo = data(:,2);
        po = data(:,3);
        No = length(to);
        switch jazyk
            case 1
                disp([' Peteno ', num2str(No), ' dk!'])
            case 2
                disp([' ', num2str(No), ' rows were read!'])
        end
        disp(' ')
        xlsdatsoubor = datsoubor;
end
disp(' ')
    switch jazyk
        case 1
            disp(' Probh zpis dat do vstupn excelovsk tabulky!!!')
            disp(' ekej, zpis dat me trvat nkolik destek vtein!!!')
        case 2
            disp (' Writing data to the output Excel spreadsheets!!')
            disp (' Wait, data entry may take a few seconds!!')
    end
disp(' ')
warning off MATLAB:xlswrite:AddSheet
[status, message] = xlswrite(xlsdatsoubor,...
    {'Time','Prolongation','Pressure';...
    '[s]','[mm]','[Pa]'},'Data','A1');
if strcmp(message.message,'Added specified worksheet.')
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' pidn list Data!!!'])
            case 2
                disp([' The Data sheet was added into the file ', ...
                    xlsdatsoubor, ' !!!'])
        end
    disp(' ')
end
[status, message] = xlswrite(xlsdatsoubor,[to,po,qo],'Data','A3');
if status == 1
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' spn zapsno ',...
                    num2str(No), ' dk!!!'])
            case 2
                disp([' ', num2str(No), ' rows were written into the file ',...
                    xlsdatsoubor, ' successfully !!!'])
        end
    disp(' ')
else
        switch jazyk
            case 1
                disp([' Zpis dat do souboru ', xlsdatsoubor,...
                    ' nebyl spn!!!'])
            case 2
                disp([' Writing data into the file ', xlsdatsoubor,...
                    ' was not successful!!!'])
        end
    return
end

%% Fyzikln parametry membrny
% Tlouka membrny
switch jazyk
    case 1
        L = input(' Zadejte hodnotu tlouky membrny   L [m]    = ');
        while ~isnumeric(L)
            disp(' Zadan hodnota tlouky membrny L nen slo, opakuj!')
            L = input(' Zadejte hodnotu tlouky membrny   L [m]    = ');
        end
    case 2
        L = input(' Enter the value of the membrane thickness    L [m]    = ');
        while ~isnumeric(L)
            disp([' The entered value of the membrane thickness L ',...
                'is not a number, repeat!'])
            L = input(' Enter the value of the membrane thickness    L [m]    = ');
        end
end
switch jazyk
    case 1
        zadanidk = menu('Odhad difuznho koeficientu',...
            'Hodnotu zad uivatel','Odhad podle metody poloasu');
    case 2
        zadanidk = menu('Estimation of the diffusion coefficient',...
            'The value entered by the user',...
            'Estimated by the half-time method');
end
close(gcf)
if zadanidk == 1
    switch jazyk
        case 1
            Dx = input(' Zadejte odhad difuznho koeficientu D [m2/s] = ');
            while ~isnumeric(Dx)
                disp(' Zadan odhad difuznho koeficientu D nen slo, opakuj!')
                Dx = input(' Zadejte odhad difuznho koeficientu D [m2/s] = ');
            end
        case 2
            Dx = input(' Enter a guess of the diffusion coefficient   D [m2/s] = ');
            while ~isnumeric(Dx)
                disp([' The entered value of the diffusion coefficient D ',...
                'is not a number, repeat!'])
                Dx = input(' Enter a guess of the diffusion coefficient   D [m2/s] = ');
            end
    end
else
    % Odhad difuznho koeficientu podle metody poloasu
    % short data
    Dx1 = pi/64/...
        to(find(abs(qo-mean(qo(end-100:end))/2)<=1e-2*mean(qo(end-100:end)),1,'last'))*L^2;
    % long data
    Dx2 = log(16/pi^2)/pi^2/...
        to(find(abs(qo-mean(qo(end-100:end))/2)<=1e-2*mean(qo(end-100:end)),1,'last'))*L^2;
    Dx = 1/2*(pi/64+log(16/pi^2)/pi^2)/...
        to(find(abs(qo-mean(qo(end-100:end))/2)<=1e-2*mean(qo(end-100:end)),1,'last'))*L^2;
    switch jazyk
        case 1
            fprintf(' Odhad difuznho koeficientu         D [m2/s] = %10.4e \n',Dx)
        case 2
            fprintf(' Estimation of the diffusion coefficient      D [m2/s] = %10.4e \n',Dx)
    end
end

%% Zobrazen namench dat
nfig = 0;
nfig = nfig+1;
% Obrzek . 1
figure(nfig), hold on, grid on
switch jazyk
    case 1
        title('Namen data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
% plot(to,qo,'b','LineWidth',1.5)
plot(to,qo,'b')
pause

%% Odstrann chybnch hodnot
%  Indikace chybnho men: pesn hodnota 1
%  oprava linern interpolac
k = 1;
kk = find(qo == 1,k,'first');
while not(isempty(kk))
    while qo(kk+1)==1
        k=k+1;
        kk=find(qo==1,k,'first');
    end
    plot(to(kk),qo(kk),'r.')
    for k1=1:length(kk)
        qo(kk(k1))=qo(kk(1)-1)+(qo(kk(end)+1)-qo(kk(1)-1))/...
            (to(kk(end)+1)-to(kk(1)-1))*(to(kk(k1))-to(kk(1)-1));
    end
    k=1;
    kk=find(qo==1,k,'first');
end
pause

%% Zobrazen namench dat po eliminaci chybnch hodnot
nfig = nfig+1;
% Obrzek . 2
figure(nfig), hold on, grid on
switch jazyk
    case 1
        title('Namen data po eliminaci chybnch hodnot')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data after elimination of erroneous values ')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
% plot(to,qo,'b','LineWidth',1.5)
plot(to,qo,'b')
pause

%% Zobrazen potku men
% redukce rozsahu dat
part = 0.1;
nfig = nfig+1;
% Obrzek . 3
figure(nfig), hold on, grid on
switch jazyk
    case 1
        title('Namen data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Measured data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
plot(to(1:fix(part*end)),qo(1:fix(part*end)),'b')
pause

%% Redukce dat - odstrann pulsu
t = to;
q = qo;
kk = 0.1;
kend = fix(kk*No);
imax=find(qo == max(qo(1:kend)));
di = 1;
i1 = imax-1;
i2 = imax;
nfig = nfig+1;
% Obrzek . 4
figure(nfig), hold on, grid on
h1 = plot(to(1:i1),qo(1:i1),'b',to(i1+1:i2),qo(i1+1:i2),'r',...
    to(i2+1:kend),qo(i2+1:kend),'b');
switch jazyk
    case 1
        title('Data vybran pro opravu - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Namen data','Vybran data','Location','Best')
    case 2
        title('Data selected for correction - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Selected data','Location','Best')
end
switch jazyk
    case 1
        h2 = text(0.10,0.95,...
            ['Doln mez = ',num2str(i1),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h3 = text(0.5,0.95,...
            ['Horn mez = ',num2str(i2),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h4 = text(0.10,0.90,...
            ['Krok = ',num2str(di),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
    case 2
        h2 = text(0.10,0.95,...
            ['Lower bound = ',num2str(i1),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h3 = text(0.5,0.95,...
            ['Upper bound = ',num2str(i2),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
        h4 = text(0.10,0.90,...
            ['Step = ',num2str(di),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
end
postup = 1;
while postup > 0
    switch jazyk
        case 1
            postup = menu('Dal postup','Men doln mez','Vt doln mez',...
                'Vt horn mez','Men horn mez','Men krok','Vt krok','Bez korekce','Konec');
        case 2
            postup = menu ('Further procedure', 'Smaller lower bound',...
                'Larger lower bound','Larger upper bound',...
                'Smaller upper bound','Smaller step',...
                'Larger step','No correction','Quit');
    end
%     close(gcf);
    switch postup
        case 1
            i1 = i1-di;
        case 2
            i1 = i1+di;
        case 3
            i2 = i2+di;
        case 4
            i2 = i2-di;
        case 5
            di = max(di-1,1);
        case 6
            di = di+1;
        case 7
            i1 = imax-1;
            i2 = imax;
        case 8
            postup = 0;
    end
%     delete(h1);
%     delete(h2);
%     delete(h3);
%     delete(h4);
    h1 = plot(to(1:i1),qo(1:i1),'b',to(i1+1:i2),qo(i1+1:i2),'r',...
        to(i2+1:kend),qo(i2+1:kend),'b');
    switch jazyk
        case 1
            h2 = text(0.10,0.95,...
                ['Doln mez = ',num2str(i1),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.5,0.95,...
                ['Horn mez = ',num2str(i2),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.10,0.90,...
                ['Krok = ',num2str(di),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
        case 2
            h2 = text(0.10,0.95,...
                ['Lower bound = ',num2str(i1),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.5,0.95,...
                ['Upper bound = ',num2str(i2),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.10,0.90,...
                ['Step = ',num2str(di),' [1]'],...
                'BackGroundColor','w','Color','r','Units','normalized');
    end
end

%% Linern interpolace
qc = (q(i2)-q(i1))/(t(i2)-t(i1))*(t(i1+1:i2-1)-t(i1))+q(i1);
q = [q(1:i1);qc;q(i2:end)];
N = length(t);
h5 = plot(t(i1+1:i2-1),q(i1+1:i2-1));
switch jazyk
    case 1
        title('Opraven namen  data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Opraven data','Namen data','Location','Best')
    case 2
        title('Corrected measured data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Corrected data','Measured data','Location','Best')
end

%% Doplnn korigovanho signlu o um
% zskn vlastnost umu ve stacionrn fzi men
value = zeros(N,1);
term = ones(N,1);
Qinf = mean(q(end-100:end));
k = 0;
while norm(term) > 1024*eps & k <= 1000
    term = exp(-(2*k+1)^2*pi^2*Dx/L^2*t)/(2*k+1)^2;
    value = value + term;
    k = k + 1;
end
qa = Qinf*(1-8/pi^2*value);

%% Vbr vlastnost umu
postup = 1;
korekce = 1;
podil = 0.1;
switch jazyk
    case 1
        h6 = text(0.50,0.90,...
            ['Korekn faktor = ',num2str(korekce),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
    case 2
        h6 = text(0.50,0.90,...
            ['Correction factor = ',num2str(korekce),' [1]'],...
            'BackGroundColor','w','Color','r','Units','normalized');
end
while postup > 0
    switch jazyk
        case 1
            postup = menu('Vbr vlastnost nhodnho umu',...
                'Podle posledn desetiny mench bod',...
                'Podle posledn ptiny mench bod',...
                'Podle posledn tvrtiny mench bod',...
                'Podle posledn tetiny mench bod',...
                'Podle posledn poloviny mench bod',...
                'Podle poslednch tech tvrtin mench bod',...
                'Zven koreknho faktoru',...
                'Snen koreknho faktoru',...
                'Konec');
        case 2
            postup = menu ('Selection of random noise properties', ...
                'By the last tenth of the data range', ...
                'By the last fifth of the data range', ...
                'By the last quarter of the data range', ...
                'By the last third of the data range', ...
                'By the last half of the data range', ...
                'By the last three quarters of the data range', ...
                'Increasing the correction factor', ...
                'Reducing the correction factor', ...
                'Quit');
    end
    
    switch postup
        case 1
            podil = 0.1;
        case 2
            podil = 0.2;
        case 3
            podil = 0.25;
        case 4
            podil = 1/3;
        case 5
            podil = 0.5;
        case 6
            podil = 0.75;
        case 7
            korekce = korekce+1;
            delete(h6);
            switch jazyk
                case 1
                    h6 = text(0.50,0.90,...
                        ['Korekn faktor = ',num2str(korekce),' [1]'],...
                        'BackGroundColor','w','Color','r','Units','normalized');
                case 2
                    h6 = text(0.50,0.90,...
                        ['Correction factor = ',num2str(korekce),' [1]'],...
                        'BackGroundColor','w','Color','r','Units','normalized');
            end
        case 8
            korekce = max(korekce-1,1);
            delete(h6);
            switch jazyk
                case 1
                    h6 = text(0.50,0.90,...
                        ['Korekn faktor = ',num2str(korekce),' [1]'],...
                        'BackGroundColor','w','Color','r','Units','normalized');
                case 2
                    h6 = text(0.50,0.90,...
                        ['Correction factor = ',num2str(korekce),' [1]'],...
                        'BackGroundColor','w','Color','r','Units','normalized');
            end
        case 9
            postup = 0;
            break;
    end
    if postup < 7
        qd = qo(fix((1-podil)*end):end)-qa(fix((1-podil)*end):end);
        qd = qd-mean(qd);
        qr = 2*rand(size(to(i1+1:i2-1)))-1;
    end
    q(i1+1:i2-1) = qc+std(qd)*korekce*qr;
    delete(h5);
    h5 = plot(t(i1+1:i2),q(i1+1:i2),'b');
end


%% Uren periody vzorkovn
T = to(2:end)-to(1:end-1);
disp('  ')
switch jazyk
    case 1
        disp(' Charakteristiky period vzorkovn:')
        fprintf(' Minimum hodnot period vzorkovn [s] = %10.4e \n',min(T))
        fprintf(' Maximum hodnot period vzorkovn [s] = %10.4e \n',max(T))
        fprintf(' Prmr  hodnot period vzorkovn [s] = %10.4e \n',mean(T))
        fprintf(' Medin  hodnot period vzorkovn [s] = %10.4e \n',median(T))
        fprintf(' Modus   hodnot period vzorkovn [s] = %10.4e \n',mode(T))
    case 2
        disp(' Characteristics of sampling periods:')
        fprintf(' The minimum of sampling periods [s] = %10.4e \n',min(T))
        fprintf(' The maximum of sampling periods [s] = %10.4e \n',max(T))
        fprintf(' The average of sampling periods [s] = %10.4e \n',mean(T))
        fprintf(' The median  of sampling periods [s] = %10.4e \n',median(T))
        fprintf(' The modus   of sampling periods [s] = %10.4e \n',mode(T))
end
disp(' ')
Ts = round(median(T)*10)/10;
switch jazyk
    case 1
        fprintf(' Zvolen hodnota periody vzorkovn [s] = %10.4e \n',Ts)
    case 2
        fprintf(' The selected sampling period [s] = %10.4e \n',Ts)
end

%% Neekvidistantn data - pevzorkovan pomoc interpolace
ti = (floor(to(1)/Ts)*Ts:Ts:ceil(to(end)/Ts)*Ts)';
% interpolace signlu na ekvidistantn
Ni = length(ti);
% Vbr interpolan metody
switch jazyk
    case 1
        interpolace = menu('Vbr interpolan metody','Linern',...
            'Nejbli okol','Kubick splajnov',...
            'Po stech kubick Hermitovsk');
    case 2
        interpolace = menu('Selection of interpolation method','Linear',...
            'Nearest neighbor','Cubic spline',...
            'Piecewise cubic Hermite');
end
% close(gcf);
switch interpolace
    case 1
        metoda = 'linear';
    case 2
        metoda = 'nearest';
    case 3
        metoda = 'spline';
    case 4
        metoda = 'cubic';
end
% interpolace signlu na ekvidistantn
qi = interp1(t,q,ti,metoda);
% linern prodlouen obou konc
qi(1) = q(1)+(q(2)-q(1))/(t(2)-t(1))*(ti(1)-t(1));
qi(end) = q(end)+(q(end-1)-q(end))/(t(end-1)-t(end))*(ti(end)-t(end));

%% Srovnn korigovanch namench a interpolovanch dat
nfig = nfig+1;
% Obrzek . 5
figure(nfig), hold on, grid on
plot(t,q,'b',ti,qi,'r')
switch jazyk
    case 1
        title('Opraven men a interpolovan data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Opraven men data','Interpolovan data','Location','Best')
    case 2
        title('Corrected measured and interpolated data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Corrected measured data','Interpolated data','Location','Best')
end
pause

%% Srovnn korigovanch mench a interpolovanch dat na potku men
% redukce rozsahu dat
part = 0.1;
nfig = nfig+1;
% Obrzek . 6
figure(nfig), hold on, grid on
plot(t(1:fix(part*end)),q(1:fix(part*end)),'b')
plot(ti(1:fix(part*end)),qi(1:fix(part*end)),'r')
switch jazyk
    case 1
        title('Opraven men data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Opraven men data','Interpolovan data','Location','Best')
    case 2
        title('Corrected measured data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Corrected measured data','Interpolated data','Location','Best')
end
pause

%% Vyhlazen korigovanch namench dat
%  filtr: Savitzky-Golay
sal=1e+6;
nfig = nfig+1;
% Obrzek . 7
figure(nfig), hold on, grid on
konec = 1;
k = 1;
plot(ti,qi,'b');
plot(10*ti(1:fix(part*end)),qi(1:fix(part*end)),'b')
while konec ~= 3
    qf = sgolayfilt(qi,1,41+10*(k-1));
    h1 = plot(ti,qf,'r');
    h2 = plot(10*ti(1:fix(part*end)),qf(1:fix(part*end)),'r');
    switch jazyk
        case 1
            title('Vyhlazovn namench dat - filtr Savitzky-Golay');
            legend('Interpolovan data','Interpolovan data - zatek',...
                'Vyhlazovan data','Vyhlazovan data - zatek','Location','Best')
        case 2
            title('Smoothing of measured data - Savitzky-Golay filter');
            legend('Interpolated data','Interpolated data - beginning',...
                'Smoothed data','Smoothed data - beginning','Location','Best')
    end
    sal = abs(sum(qi-qf));
    switch jazyk
        case 1
            h3 = text(0.50,0.90,...
                ['Kritrium = ',num2str(sal),' '],...
                'BackGroundColor','w','Color','r','Units','normalized');
        case 2
            h3 = text(0.50,0.90,...
                ['Criterion = ',num2str(sal),' '],...
                'BackGroundColor','w','Color','r','Units','normalized');
    end
    switch jazyk
        case 1
            konec = menu('Vyhlazovn dat - Savitzky-Golayv filtr',...
                'Pokraovn - vt okno',...
                'Zpt - men okno','Konec');
        case 2
            konec = menu('Data smoothing - Savitzky-Golay filter',...
                'Continuation - larger window',...
                'Return - smaller window','Quit');
            
    end
    switch konec
        case 1
            k = k+1;
            delete(h1);
            delete(h2);
            delete(h3);
        case 2
            k = max(-2,k-1);
            delete(h1);
            delete(h2);
            delete(h3);
        case 3
    end
end

%% Zptn pevzorkovn dat
% zobrazen namench a vyhlazench dat
nfig = nfig+1;
% Obrzek . 8
figure(nfig), hold on, grid on
plot(to,qo,'b')
qs = interp1(ti,qf,t);
% linern prodlouen obou konc
qs(1) = qf(1)+(qf(2)-qf(1))/(ti(2)-ti(1))*(t(1)-ti(1));
qs(end) = qf(end)+(qf(end-1)-qf(end))/(ti(end-1)-ti(end))*(t(end)-ti(end));
plot(to,qs,'r')
switch jazyk
    case 1
        title('Namen a zptn pevzorkovan vyhlazen data')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Namen data','Zptn pevzorkovan vyhlazen data','Location','Best')
    case 2
        title('Measured and back-resampled smoothed data')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Back-resampled smoothed data','Location','Best')
end
pause

%% Srovnn korigovanch mench a interpolovanch dat na potku men
% redukce rozsahu dat
part = 0.1;
nfig = nfig+1;
% Obrzek . 9
figure(nfig), hold on, grid on
plot(to(1:fix(part*end)),qo(1:fix(part*end)),'b')
plot(to(1:fix(part*end)),qs(1:fix(part*end)),'r')
switch jazyk
    case 1
        title('Men a zptn pevzorkovan vyhlazen data - zatek')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        legend('Namen data','Zptn pevzorkovan vyhlazen data','Location','Best')
    case 2
        title('Measured and back-resampled smoothed data - beginning')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        legend('Measured data','Back-resampled smoothed data','Location','Best')
end
pause

%% Parametry optimalizace
%  Metoda prunho mnohostnu fminsearch
disp(' ')
switch jazyk
    case 1
        disp(' Parametry optimalizace')
    case 2
        disp(' Optimization parameters')
end
disp(' ')

OptSearch = optimset('fminsearch');
OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
    'TolX',Dx*eps,'TolFun',1024*eps);
% OptSearch = optimset(OptSearch,'Display','iter')
switch jazyk
    case 1
        fprintf('Maximln poet iterac            : %10d \n',OptSearch.MaxIter)
        fprintf('Maximln poet vpotu funkce     : %10d \n',OptSearch.MaxFunEvals)
        fprintf('Koncov kritrium zmny promnnch : %10.4e \n',OptSearch.TolX)
        fprintf('Koncov kritrium zmny funkce     : %10.4e \n',OptSearch.TolFun)
    case 2
        fprintf('Maximum number of iterations                : %10d \n',OptSearch.MaxIter)
        fprintf('Maximum number of function evaluations      : %10d \n',OptSearch.MaxFunEvals)
        fprintf('Termination tolerance on the variables      : %10.4e \n',OptSearch.TolX)
        fprintf('Termination tolerance on the function value : %10.4e \n',OptSearch.TolFun)
end

%% Vbr intervalu optimalizace
nfig = nfig+1;
% Obrzek . 10
figure(nfig), hold on, grid on
switch jazyk
    case 1
        title('Vbr rozsahu optimalizace')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
    case 2
        title('Optimization range selection')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
end
plot(to,qo,'b')

i1 = 1;
i2 = No;
step = 100;
smer = 1;
postup = 1;
while postup > 0
    h = plot([to(i1),to(i2)],[qo(i1),qo(i2)],'ro',...
        'MarkerFaceColor','r','MarkerSize',10);
    h0 = plot(to(i1:i2),qo(i1:i2),'r');
    switch jazyk
        case 1
            h1 = text(0.6,0.25,...
                ['Horn mez = ',num2str(i2),'   ',num2str(round(i2/No*100)),' %'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h2 = text(0.6,0.20,...
                ['Doln mez = ',num2str(i1),'       ',num2str(round(i1/No*100)),' %'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.6,0.15,...
                ['Krok = ',num2str(step)],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.6,0.10,...
                ['Smr = ',num2str(smer)],...
                'BackGroundColor','w','Color','r','Units','normalized');
        case 2
            h1 = text(0.6,0.25,...
                ['Upper bound = ',num2str(i2),'   ',num2str(round(i2/No*100)),' %'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h2 = text(0.6,0.20,...
                ['Lower bound = ',num2str(i1),'       ',num2str(round(i1/No*100)),' %'],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h3 = text(0.6,0.15,...
                ['Step = ',num2str(step)],...
                'BackGroundColor','w','Color','r','Units','normalized');
            h4 = text(0.6,0.10,...
                ['Direction = ',num2str(smer)],...
                'BackGroundColor','w','Color','r','Units','normalized');
    end
    switch jazyk
        case 1
            postup = menu('Dal postup','Zmna doln meze','Zmna horn meze',...
                'Zmna obou mez','Dvojnsobn krok','Polovin krok',...
                'Zmna smru kroku','Konec');
        case 2
            postup = menu ('Further procedure','Change of lower bound',...
                'Change of upper bound','Change of both bounds','Double step',...
                'Half step','Change of step direction','Quit');
    end
    if postup == 1
        i1 = max(i1+step,1);
    elseif postup == 2
        i2 = min(i2-step,No);
    elseif postup == 3
        i1 = max(i1+step,1);
        i2 = min(i2-step,No);
        if i1 > i2
            i1 = mean([i1,i2]);
            i2 = i1;
        end
    elseif postup == 4
        step = smer*min(2*abs(step),No);
    elseif postup == 5
        step = smer*max(abs(step)/2,1);
    elseif postup == 6
        smer = -smer;
        step = -step;
    elseif postup >= 7 | postup == 0
        postup = 0;
    end
    delete(h);
    delete(h0);
    delete(h1);
    delete(h2);
    delete(h3);
    delete(h4);
end
plot(to(i1:i2),qo(i1:i2),'r');
pause

%% Vbr verze matematickho modelu sorpce par
switch jazyk
    case 1
        metoda = menu('Vbr potu optimalizanch promnnch',...
            '1: integrln difuzn koeficient',...
            '2: pedel + mnostv sorbovanch par v ustlenm stavu',...
            '3: pedel + asov zpodn',...
            '4: pedel + svisl posun sorpnch dat');
    case 2
        metoda = menu ('Selection of the number of optimization variables', ...
            '1: Integral diffusion coefficient ', ...
            '2: Previous + mass of adsorbed vapor at steady state ', ...
            '3: Previous + time delay ', ...
            '4: Previous + vertical shift of sorption data ');
end

%% No.1 - Optimalizace hodnoty difuznho koeficientu D
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek zptn pevzorkovanch a vypotench dat
%  .1 Jednorozmrov optimalizace

if metoda >= 1
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh optimalizace!!!')
            disp(' ekejte, vpoet me trvat a nkolik minut!!!')
        case 2
            disp(' Optimization is in progress!!!')
            disp(' Wait, calculation may take several minutes!!!')
    end
    disp(' ')
    OptSearch = optimset('fminsearch');
    OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
        'TolX',Dx*eps,'TolFun',1e+2*eps);
    tStart=tic;
    [D1,GoalFcn1Min,ExitFlag,Output] = fminsearch(@GoalFcn1,Dx,OptSearch);
    tElapsed = toc(tStart);
    
    switch jazyk
        case 1
            fprintf(' Vsledky 1D-optimalizace vyhlazench dat\n \n')
            fprintf(' Difuzn koeficient : %10.4e [m2/s] \n',D1)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum nalezeno spn za %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' Dosaen maximln poet iterac!!!')
                case -1
                    disp(' Vpoet ukonen chybou v elov funkci!!!')
            end
        case 2
            fprintf(' Results of 1D-optimization for smoothed data\n \n')
            fprintf(' Diffusion coefficient : %10.4e [m2/s] \n',D1)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum found successfully for %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' The maximum number of iterations achieved!!!')
                case -1
                    disp('Calculations terminated by an error in the objective function!!!')
            end
    end
    
    % Tisk vsledk do Excelu
    value = zeros(No,1);
    term = ones(No,1);
    k = 0;
    while norm(term) > eps & k <= 1000
        term = exp(-(2*k+1)^2*pi^2*D1/L^2*to)/(2*k+1)^2;
        value = value + term;
        k = k + 1;
    end
    qa1 = qs(end)*(1-8/pi^2*value);
    
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh zpis vsledk do vstupn excelovsk tabulky!!!')
            disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
        case 2
            disp(' Writing results to the output Excel spreadsheets!!!')
            disp(' Wait, data entry may take a few seconds!!!')
    end
    disp(' ')
    warning off MATLAB:xlswrite:AddSheet
    [status, message] = xlswrite(xlsdatsoubor,...
        {'Time','Measured data','1D model data';...
        '[s]','[mm]','[mm]'},'Results','A1');
    if strcmp(message.message,'Added specified worksheet.')
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' pidn list Results!!!'])
            case 2
                disp([' The Results sheet was added into the file ', ...
                    xlsdatsoubor, ' !!!'])
        end
        disp(' ')
    end
    [status, message] = xlswrite(xlsdatsoubor,[to,qo,qa1],'Results','A3');
    if status == 1
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' spn zapsno ',...
                    num2str(No), ' dk!!!'])
            case 2
                disp([' ', num2str(No), ' rows were written into the file ',...
                    xlsdatsoubor, ' successfully !!!'])
        end
        disp(' ')
    else
        switch jazyk
            case 1
                disp([' Zpis dat do souboru ', xlsdatsoubor,...
                    ' nebyl spn!!!'])
            case 2
                disp([' Writing data into the file ', xlsdatsoubor,...
                    ' was not successful!!!'])
        end
        return
    end
    
    % Zobrazen vsledk 1D optimalizace
    nfig = nfig+1;
    % Obrzek . 11
    figure(nfig), hold on, grid on
    plot(to(1:50:end),qs(1:50:end),'bx')
    plot(to,qa1,'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 1D optimalizovanho modelu')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 1D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 1D-optimized model fitted data')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','1D-optimized model fitted data','Location','Best')
    end
    pause
    
    kk = 0.2;
    nfig = nfig+1;
    % Obrzek . 12
    figure(nfig), hold on, grid on
    plot([to(1:10:fix(kk*end))],[qs(1:10:fix(kk*end))],'bx')
    plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 1D optimalizovanho modelu - zatek')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 1D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 1D-optimized model data - beginning')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','1D-optimized model data','Location','Best')
    end
    pause
end

%% No.2 - Optimalizace hodnoty difuznho koeficientu D a
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek vyhlazench a namench dat
%  .2 Dvourozmrov optimalizace

if metoda >= 2
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh optimalizace!!!')
            disp(' ekejte, vpoet me trvat a nkolik minut!!!')
        case 2
            disp(' Optimization is in progress!!!')
            disp(' Wait, calculation may take several minutes!!!')
    end
    disp(' ')
    Q0 = q(end);
    x0 = [Dx,Q0];
    OptSearch = optimset('fminsearch');
    OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
        'TolX',Dx*eps,'TolFun',1e+2*eps);
    tStart=tic;
    [x,GoalFcn2Min,ExitFlag,Output] = fminsearch(@GoalFcn2,x0,OptSearch);
    tElapsed = toc(tStart);
    D2 = x(1);
    Q2 = x(2);

    switch jazyk
        case 1
            fprintf(' Vsledky 2D-optimalizace vyhlazench dat\n \n')
            fprintf(' Difuzn koeficient : %10.4e [m2/s] \n',D2)
            fprintf(' Ustlen hodnota   : %10.4e [mm] \n',Q2)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum nalezeno spn za %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' Dosaen maximln poet iterac!!!')
                case -1
                    disp(' Vpoet ukonen chybou v elov funkci!!!')
            end
        case 2
            fprintf(' Results of 2D-optimization for smoothed data\n \n')
            fprintf(' Diffusion coefficient : %10.4e [m2/s] \n',D2)
            fprintf(' Steady-state value    : %10.4e [mm] \n',Q2)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum found successfully for %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' The maximum number of iterations achieved!!!')
                case -1
                    disp('Calculations terminated by an error in the objective function!!!')
            end
    end

    % Tisk vsledk do Excelu
    value = zeros(No,1);
    term = ones(No,1);
    k = 0;
    while norm(term) > eps & k <= 1000
        term = exp(-(2*k+1)^2*pi^2*D2/L^2*to)/(2*k+1)^2;
        value = value + term;
        k = k + 1;
    end
    qa2 = Q2*(1-8/pi^2*value);
    
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh zpis vsledk do vstupn excelovsk tabulky!!!')
            disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
        case 2
            disp(' Writing results to the output Excel spreadsheets!!!')
            disp(' Wait, data entry may take a few seconds!!!')
    end
    disp(' ')
    warning off MATLAB:xlswrite:AddSheet
    [status, message] = xlswrite(xlsdatsoubor,...
        {'2D model data';'[mm]'},'Results','D1');
    if strcmp(message.message,'Added specified worksheet.')
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' pidn list Results!!!'])
            case 2
                disp([' The Results sheet was added into the file ', ...
                    xlsdatsoubor, ' !!!'])
        end
        disp(' ')
    end
    [status, message] = xlswrite(xlsdatsoubor,qa2,'Results','D3');
    if status == 1
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' spn zapsno ',...
                    num2str(No), ' dk!!!'])
            case 2
                disp([' ', num2str(No), ' rows were written into the file ',...
                    xlsdatsoubor, ' successfully !!!'])
        end
        disp(' ')
    else
        switch jazyk
            case 1
                disp([' Zpis dat do souboru ', xlsdatsoubor,...
                    ' nebyl spn!!!'])
            case 2
                disp([' Writing data into the file ', xlsdatsoubor,...
                    ' was not successful!!!'])
        end
        return
    end
    
    % Zobrazen vsledk
    nfig = nfig+1;
    % Obrzek . 13
    figure(nfig), hold on, grid on
    plot(to(1:50:end),qs(1:50:end),'bx')
    plot(to,qa2,'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 2D optimalizovanho modelu')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 2D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 2D-optimized model fitted data')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','2D-optimized model fitted data','Location','Best')
    end
    pause
    
    kk = 0.2;
    nfig = nfig+1;
    % Obrzek . 14
    figure(nfig), hold on, grid on
    plot([to(1:10:fix(kk*end))],[qs(1:10:fix(kk*end))],'bx')
    plot([to(1:fix(kk*end))],[qa2(1:fix(kk*end))],'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 2D optimalizovanho modelu - zatek')
            xlabel('as [t]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 2D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 2D-optimized model data - beginning')
            xlabel('Time [t]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','2D-optimized model data','Location','Best')
    end
end


%% No.3 - Optimalizace hodnoty difuznho koeficientu D,
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf
%  a zpodn signlu Td
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek filtrovanch a vypotench dat
%  .3 Trojrozmrov optimalizace

if metoda >= 3
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh optimalizace!!!')
            disp(' ekejte, vpoet me trvat a nkolik minut!!!')
        case 2
            disp(' Optimization is in progress!!!')
            disp(' Wait, calculation may take several minutes!!!')
    end
    disp(' ')
    Q0 = mean(q(No-100:No));
    n0 = length(qs(abs((qs-qs(2))/qs(2))<1.0));
    T0 = t(n0);
    x0 = [Dx,Q0,T0];
    OptSearch = optimset('fminsearch');
    OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
        'TolX',Dx*eps,'TolFun',1e+2*eps);
    tStart=tic;
    [x,GoalFcn3Min,ExitFlag,Output] = fminsearch(@GoalFcn3,x0,OptSearch);
    tElapsed = toc(tStart);
    D3 = x(1);
    Q3 = x(2);
    T3 = x(3);
    
    switch jazyk
        case 1
            fprintf(' Vsledky 3D-optimalizace vyhlazench dat\n \n')
            fprintf(' Difuzn koeficient : %10.4e [m2/s] \n',D3)
            fprintf(' Ustlen hodnota   : %10.4e [mm] \n',Q3)
            fprintf(' Zpodn signlu   : %10.4e [s] \n',T3)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum nalezeno spn za %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' Dosaen maximln poet iterac!!!')
                case -1
                    disp(' Vpoet ukonen chybou v elov funkci!!!')
            end
        case 2
            fprintf(' Results of 3D-optimization for smoothed data\n \n')
            fprintf(' Diffusion coefficient : %10.4e [m2/s] \n',D3)
            fprintf(' Steady-state value    : %10.4e [mm] \n',Q3)
            fprintf(' Signal time delay     : %10.4e [s] \n',T3)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum found successfully for %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' The maximum number of iterations achieved!!!')
                case -1
                    disp('Calculations terminated by an error in the objective function!!!')
            end
    end

    % Tisk vsledk do Excelu
    value = zeros(No,1);
    term = ones(No,1);
    k = 0;
    idelay=find(to(to<T3),1,'last');
    hh=[zeros(idelay,1);ones(No-idelay,1)];
    tt=[to(to<T3);to(to>=T3)-T3];
    while norm(term) > eps & k <= 1000
        term = hh.*exp(-(2*k+1)^2*pi^2*D3/L^2*tt)/(2*k+1)^2;
        value = value + term;
        k = k + 1;
    end
    qa3 = hh.*(Q3*(1-8/pi^2*value));
    
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh zpis vsledk do vstupn excelovsk tabulky!!!')
            disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
        case 2
            disp(' Writing results to the output Excel spreadsheets!!!')
            disp(' Wait, data entry may take a few seconds!!!')
    end
    disp(' ')
    warning off MATLAB:xlswrite:AddSheet
    [status, message] = xlswrite(xlsdatsoubor,...
        {'3D model data';'[mm]'},'Results','E1');
    if strcmp(message.message,'Added specified worksheet.')
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' pidn list Results!!!'])
            case 2
                disp([' The Results sheet was added into the file ', ...
                    xlsdatsoubor, ' !!!'])
        end
        disp(' ')
    end
    [status, message] = xlswrite(xlsdatsoubor,qa3,'Results','E3');
    if status == 1
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' spn zapsno ',...
                    num2str(No), ' dk!!!'])
            case 2
                disp([' ', num2str(No), ' rows were written into the file ',...
                    xlsdatsoubor, ' successfully !!!'])
        end
        disp(' ')
    else
        switch jazyk
            case 1
                disp([' Zpis dat do souboru ', xlsdatsoubor,...
                    ' nebyl spn!!!'])
            case 2
                disp([' Writing data into the file ', xlsdatsoubor,...
                    ' was not successful!!!'])
        end
        return
    end
    
    % Zobrazen vsledk
    nfig = nfig+1;
    % Obrzek . 15
    figure(nfig), hold on, grid on
    plot(to(1:50:end),qs(1:50:end),'bx')
    plot(to,qa3,'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 3D optimalizovanho modelu')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 3D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 3D-optimized model fitted data')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','3D-optimized model fitted data','Location','Best')
    end
    pause
    
    kk = 0.2;
    nfig = nfig+1;
    % Obrzek . 16
    figure(nfig), hold on, grid on
    plot([to(1:10:fix(kk*end))],[qs(1:10:fix(kk*end))],'bx')
    plot([to(1:fix(kk*end))],[qa3(1:fix(kk*end))],'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 3D optimalizovanho modelu - zatek')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 3D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 3D-optimized model data - beginning')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','3D-optimized model data','Location','Best')
    end
    pause
end

%% No.4 - Optimalizace hodnoty difuznho koeficientu D,
%  ustlen hodnoty polohy kalibranch bod v sorpn rovnovze Qinf,
%  zpodn signlu Td a posunu dat q0
%  Metoda prunho mnohostnu fminsearch
%  elov funkce souet tverc odchylek filtrovanch a vypotench dat
%  .4 tyrozmrov optimalizace

if metoda >= 4
    disp(' ')
    switch jazyk
        case 1
            disp(' Probh optimalizace!!!')
            disp(' ekejte, vpoet me trvat a nkolik minut!!!')
        case 2
            disp(' Optimization is in progress!!!')
            disp(' Wait, calculation may take several minutes!!!')
    end
    disp(' ')
    Q0 = mean(qs(No-100:No));
    n0 = length(qs(abs((qs-qs(2))/qs(2))<1.0));
    T0 = to(n0);
    q0 = mean(qs(1:10));
    x0 = [Dx,Q0,T0,q0];
    OptSearch = optimset('fminsearch');
    OptSearch = optimset(OptSearch,'MaxFunEvals',10000,'MaxIter',10000,...
        'TolX',Dx*eps,'TolFun',1e+2*eps);
    tStart=tic;
    [x,GoalFcn4Min,ExitFlag,Output] = fminsearch(@GoalFcn4,x0,OptSearch);
    tElapsed = toc(tStart);
    D4 = x(1);
    Q4 = x(2);
    T4 = x(3);
    q4 = x(4);

    switch jazyk
        case 1
            fprintf(' Vsledky 4D-optimalizace vyhlazench dat\n \n')
            fprintf(' Difuzn koeficient : %10.4e [m2/s] \n',D4)
            fprintf(' Ustlen hodnota   : %10.4e [mm] \n',Q4)
            fprintf(' Zpodn signlu   : %10.4e [s] \n',T4)
            fprintf(' Svisl posun dat   : %10.4e [s] \n',q4)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum nalezeno spn za %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' Dosaen maximln poet iterac!!!')
                case -1
                    disp(' Vpoet ukonen chybou v elov funkci!!!')
            end
        case 2
            fprintf(' Results of 4D-optimization for smoothed data\n \n')
            fprintf(' Diffusion coefficient  : %10.4e [m2/s] \n',D4)
            fprintf(' Steady-state value     : %10.4e [mm] \n',Q4)
            fprintf(' Signal time delay      : %10.4e [s] \n',T4)
            fprintf(' Vertical shift of data : %10.4e [s] \n',q4)
            switch ExitFlag
                case 1
                    fprintf('\n Optimum found successfully for %10.4f s!!! \n',tElapsed)
                case 0
                    disp(' The maximum number of iterations achieved!!!')
                case -1
                    disp('Calculations terminated by an error in the objective function!!!')
            end
    end

    % Tisk vsledk do Excelu
    value = zeros(No,1);
    term = ones(No,1);
    idelay=find(to(to<T4),1,'last');
    if isempty(idelay)
        hh = [ones(No,1)];
    else
        hh = [zeros(idelay,1);ones(No-idelay,1)];
    end
    tt=[to(to<T4);to(to>=T4)-T4];
    k = 0;
    while norm(term) > eps & k <= 1000
        %     term = exp(-(2*k+1)^2*pi^2*D4/L^2*(t(i1:i2)-T4).*...
        %         (abs(sign(t(i1:i2)-T4))+sign(t(i1:i2)-T4))/2)/(2*k+1)^2;
        term = hh.*exp(-(2*k+1)^2*pi^2*D4/L^2*tt)/(2*k+1)^2;
        value = value + term;
        k = k + 1;
    end
    qa4 = hh.*(Q4*(1-8/pi^2*value))+q4;
    
    disp('')
    switch jazyk
        case 1
            disp(' Probh zpis vsledk do vstupn excelovsk tabulky!!!')
            disp(' ekejte, zpis dat me trvat nkolik destek vtein!!!')
        case 2
            disp(' Writing results to the output Excel spreadsheets!!!')
            disp(' Wait, data entry may take a few seconds!!!')
    end
    disp(' ')
    warning off MATLAB:xlswrite:AddSheet
    [status, message] = xlswrite(xlsdatsoubor,...
        {'4D model data';'[mm]'},'Results','F1');
    if strcmp(message.message,'Added specified worksheet.')
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' pidn list Results!!!'])
            case 2
                disp([' The Results sheet was added into the file ', ...
                    xlsdatsoubor, ' !!!'])
        end
        disp(' ')
    end
    [status, message] = xlswrite(xlsdatsoubor,qa4,'Results','F3');
    if status == 1
        switch jazyk
            case 1
                disp([' Do souboru ', xlsdatsoubor, ' spn zapsno ',...
                    num2str(No), ' dk!!!'])
            case 2
                disp([' ', num2str(No), ' rows were written into the file ',...
                    xlsdatsoubor, ' successfully !!!'])
        end
        disp(' ')
    else
        switch jazyk
            case 1
                disp([' Zpis dat do souboru ', xlsdatsoubor,...
                    ' nebyl spn!!!'])
            case 2
                disp([' Writing data into the file ', xlsdatsoubor,...
                    ' was not successful!!!'])
        end
        return
    end
    
    % Zobrazen vsledk
    nfig = nfig+1;
    % Obrzek . 17
    figure(nfig), hold on, grid on
    plot(to(1:50:end),qs(1:50:end),'bx')
    plot(to,qa4,'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 4D optimalizovanho modelu')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 4D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 4D-optimized model fitted data')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','4D-optimized model fitted data','Location','Best')
    end
    pause
    
    kk = 0.2;
    nfig = nfig+1;
    % Obrzek . 18
    figure(nfig), hold on, grid on
    plot([to(1:10:fix(kk*end))],[qs(1:10:fix(kk*end))],'bx')
    plot([to(1:fix(kk*end))],[qa4(1:fix(kk*end))],'r')
    switch jazyk
        case 1
            title('Pevzorkovan vyhlazen data a data vypoten z 4D optimalizovanho modelu - zatek')
            xlabel('as t [s]'), ylabel('Poloha q [mm]')
            legend('Pevzorkovan vyhlazen data','Data vypoten z 4D optimalizovanho modelu',...
                'Location','Best')
        case 2
            title('Resampled smoothed and 4D-optimized model data - beginning')
            xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
            legend('Resampled smoothed data','4D-optimized model data','Location','Best')
    end
    pause
end

%% Srovnn model dat
kk = 0.2;
nfig = nfig+1;
% Obrzek . 19
figure(nfig), hold on, grid on
plot([to(1:fix(kk*end))],[qo(1:fix(kk*end))],'y')
plot([to(1:10:fix(kk*end))],[qs(1:10:fix(kk*end))],'kx')
switch metoda
    case 1
        plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'m')
    case 2
        plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'m')
        plot([to(1:fix(kk*end))],[qa2(1:fix(kk*end))],'g')
    case 3
        plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'m')
        plot([to(1:fix(kk*end))],[qa2(1:fix(kk*end))],'g')
        plot([to(1:fix(kk*end))],[qa3(1:fix(kk*end))],'b')
    case 4
        plot([to(1:fix(kk*end))],[qa1(1:fix(kk*end))],'m')
        plot([to(1:fix(kk*end))],[qa2(1:fix(kk*end))],'g')
        plot([to(1:fix(kk*end))],[qa3(1:fix(kk*end))],'b')
        plot([to(1:fix(kk*end))],[qa4(1:fix(kk*end))],'r')
end
switch jazyk
    case 1
        title('Srovnn optimalizovanch model - zatek men')
        xlabel('as t [s]'), ylabel('Poloha q [mm]')
        switch metoda
            case 1
                legend('Men data','Pevzorkovan vyhlazen data',...
                    'Data vypoten z 1D optimalizovanho modelu',...
                    'Location','Best')
            case 2
                legend('Men data','Pevzorkovan vyhlazen data',...
                    'Data vypoten z 1D optimalizovanho modelu',...
                    'Data vypoten z 2D optimalizovanho modelu',...
                    'Location','Best')
            case 3
                legend('Men data','Pevzorkovan vyhlazen data',...
                    'Data vypoten z 1D optimalizovanho modelu',...
                    'Data vypoten z 2D optimalizovanho modelu',...
                    'Data vypoten z 3D optimalizovanho modelu',...
                    'Location','Best')
            case 4
                legend('Men data','Pevzorkovan vyhlazen data',...
                    'Data vypoten z 1D optimalizovanho modelu',...
                    'Data vypoten z 2D optimalizovanho modelu',...
                    'Data vypoten z 3D optimalizovanho modelu',...
                    'Data vypoten z 4D optimalizovanho modelu',...
                    'Location','Best')
        end
    case 2
        title('Comparison of optimized models - beginning of measurement')
        xlabel('Time t [s]'), ylabel('Spiral prolongation q [mm]')
        switch metoda
            case 1
                legend('Measured data','Resampled smoothed data',...
                    '1D-optimized model data','Location','Best')
            case 2
                legend('Measured data','Resampled smoothed data',...
                    '1D-optimized model data','2D-optimized model data',...
                    'Location','Best')
            case 3
                legend('Measured data','Resampled smoothed data',...
                    '1D-optimized model data','2D-optimized model data',...
                    '3D-optimized model data','Location','Best')
            case 4
                legend('Measured data','Resampled smoothed data',...
                    '1D-optimized model data','2D-optimized model data',...
                    '3D-optimized model data','4D-optimized model data',...
                    'Location','Best')
        end
end
pause
return

